diff --git a/distrib/utils/sysinst/partman.c b/distrib/utils/sysinst/partman.c
index c1453cd..61248ab 100644
--- a/distrib/utils/sysinst/partman.c
+++ b/distrib/utils/sysinst/partman.c
@@ -526,141 +676,163 @@ partman_raid_commit(void)
 
 		/* Raid initialization */
 		if (
-			run_program(RUN_DISPLAY, "raidctl -C %s raid%d",
-							f_name, raid_devnum) == 0 &&
-			run_program(RUN_DISPLAY, "raidctl -I %d raid%d",
-							rand(), raid_devnum) == 0 &&
-			run_program(RUN_DISPLAY, "raidctl -vi raid%d",
-							raid_devnum) == 0
-			)
-			raids[i].enabled = 0; /* RAID creation done, remove it from list to 
+			run_program(RUN_DISPLAY | RUN_PROGRESS, "raidctl -C %s raid%d",
+							f_name, raids[i].node) == 0 &&
+			run_program(RUN_DISPLAY | RUN_PROGRESS, "raidctl -I %d raid%d",
+							rand(), raids[i].node) == 0 &&
+			run_program(RUN_DISPLAY | RUN_PROGRESS, "raidctl -vi raid%d",
+							raids[i].node) == 0 &&
+			run_program(RUN_DISPLAY | RUN_PROGRESS, "raidctl -v -A yes raid%d",
+							raids[i].node) == 0
+			) {
+			raids[i].blocked = 1; /* RAID creation done, remove it from list to 
 									 prevent it's repeated reinitialization */
+			for (ii = 0; ii < MAX_IN_RAID; ii++)
+				if (raids[i].pm[ii] != NULL)
+					raids[i].pm[ii]->blocked++;
+		}
 	}
 	return 0;
 }
 
-/*** VND ***/
+/***
+VND
+***/
 
 static void
-partman_vnd_menufmt(menudesc *m, int opt, void *arg)
+pm_vnd_menufmt(menudesc *m, int opt, void *arg)
 {
-	int num = ((part_entry_t *)arg)[opt].dev_num;
-
-	if (vnds[num].enabled != 0) {
-		if (strlen(vnds[num].filepath) < 1)
-			wprintw(m->mw, "   PATH NOT DEFINED!");
-		else
-			wprintw(m->mw, "   %s (%dMB)", vnds[num].filepath, vnds[num].size);
-	}
+	vnds_t *dev_ptr = ((part_entry_t *)arg)[opt].dev_ptr;
+
+	if (dev_ptr->enabled == 0)
+		return;
+	if (strlen(dev_ptr->filepath) < 1)
+		wprintw(m->mw, "%s", msg_string(MSG_vnd_err_menufmt));
+	else if (dev_ptr->is_exist)
+		wprintw(m->mw, msg_string(MSG_vnd_assgn_menufmt),
+			dev_ptr->node, dev_ptr->filepath);
+	else 
+		wprintw(m->mw, msg_string(MSG_vnd_menufmt),
+			dev_ptr->node, dev_ptr->filepath, dev_ptr->size);
 	return;
 }
 
 static void
-partman_vnd_edit_menufmt(menudesc *m, int opt, void *arg)
+pm_vnd_edit_menufmt(menudesc *m, int opt, void *arg)
 {
+	vnds_t *dev_ptr = arg;
 	char buf[SSTRSIZE];
 	strcpy(buf, "-");
 
-	switch (opt){
+	switch (opt) {
 		case PMV_MENU_FILEPATH:
-			wprintw(m->mw, "File path: %29s", vnds[manage_curdev].filepath);
+			wprintw(m->mw, msg_string(MSG_vnd_path_fmt), dev_ptr->filepath);
 			break;
 		case PMV_MENU_EXIST:
-			wprintw(m->mw, "Assign exist image: %20s", vnds[manage_curdev].is_exist?"yes":"no");
+			wprintw(m->mw, msg_string(MSG_vnd_assgn_fmt),
+				dev_ptr->is_exist? msg_string(MSG_Yes) : msg_string(MSG_No));
 			break;
 		case PMV_MENU_SIZE:
-			if (!vnds[manage_curdev].is_exist)
-				snprintf(buf, SSTRSIZE, "%d", vnds[manage_curdev].size);
-			wprintw(m->mw, "Size (MB):        %22s", buf);
+			if (!dev_ptr->is_exist)
+				snprintf(buf, SSTRSIZE, "%d", dev_ptr->size);
+			wprintw(m->mw, msg_string(MSG_vnd_size_fmt), buf);
 			break;
 		case PMV_MENU_RO:
-			wprintw(m->mw, "Read-only:        %22s", vnds[manage_curdev].readonly?"yes":"no");
+			wprintw(m->mw, msg_string(MSG_vnd_ro_fmt),
+				dev_ptr->readonly? msg_string(MSG_Yes) : msg_string(MSG_No));
 			break;
 		case PMV_MENU_MGEOM:
-			if (!vnds[manage_curdev].is_exist)
-				snprintf(buf, SSTRSIZE, "%s", vnds[manage_curdev].manual_geom?"yes":"no");
-			wprintw(m->mw, "Set geometry by hand: %18s", buf);
+			if (!dev_ptr->is_exist)
+				snprintf(buf, SSTRSIZE, "%s",
+					dev_ptr->manual_geom? msg_string(MSG_Yes) : msg_string(MSG_No));
+			wprintw(m->mw, msg_string(MSG_vnd_geom_fmt), buf);
 			break;
 		case PMV_MENU_SECSIZE:
-			if (vnds[manage_curdev].manual_geom && !vnds[manage_curdev].is_exist)
-				snprintf(buf, SSTRSIZE, "%d", vnds[manage_curdev].secsize);
-			wprintw(m->mw, "Bytes per Sector:     %18s", buf);
+			if (dev_ptr->manual_geom && !dev_ptr->is_exist)
+				snprintf(buf, SSTRSIZE, "%d", dev_ptr->secsize);
+			wprintw(m->mw, msg_string(MSG_vnd_bps_fmt), buf);
 			break;
 		case PMV_MENU_NSECTORS:
-			if (vnds[manage_curdev].manual_geom && !vnds[manage_curdev].is_exist)
-				snprintf(buf, SSTRSIZE, "%d", vnds[manage_curdev].nsectors);
-			wprintw(m->mw, "Sectors per Track:    %18s", buf);
+			if (dev_ptr->manual_geom && !dev_ptr->is_exist)
+				snprintf(buf, SSTRSIZE, "%d", dev_ptr->nsectors);
+			wprintw(m->mw, msg_string(MSG_vnd_spt_fmt), buf);
 			break;
 		case PMV_MENU_NTRACKS:
-			if (vnds[manage_curdev].manual_geom && !vnds[manage_curdev].is_exist)
-				snprintf(buf, SSTRSIZE, "%d", vnds[manage_curdev].ntracks);
-			wprintw(m->mw, "Tracks per Cylinder:  %18s", buf);
+			if (dev_ptr->manual_geom && !dev_ptr->is_exist)
+				snprintf(buf, SSTRSIZE, "%d", dev_ptr->ntracks);
+			wprintw(m->mw, msg_string(MSG_vnd_tpc_fmt), buf);
 			break;
 		case PMV_MENU_NCYLINDERS:
-			if (vnds[manage_curdev].manual_geom && !vnds[manage_curdev].is_exist)
-				snprintf(buf, SSTRSIZE, "%d", vnds[manage_curdev].ncylinders);
-			wprintw(m->mw, "Cylinders:        %22s", buf);
+			if (dev_ptr->manual_geom && !dev_ptr->is_exist)
+				snprintf(buf, SSTRSIZE, "%d", dev_ptr->ncylinders);
+			wprintw(m->mw, msg_string(MSG_vnd_cyl_fmt), buf);
 			break;
-
 	}
 	return;
 }
 
 static int
-partman_vnd_set_value(menudesc *m, void *arg)
+pm_vnd_set_value(menudesc *m, void *arg)
 {
-	char buf[SSTRSIZE];
+	vnds_t *dev_ptr = arg;
+	char buf[STRSIZE];
 	const char *msg_to_show = NULL;
 	int *out_var = NULL;
 	
 	switch (m->cursel) {
 		case PMV_MENU_FILEPATH:
-			msg_prompt_win("File path?", -1, 18, 0, 0, vnds[manage_curdev].filepath,
-				vnds[manage_curdev].filepath, STRSIZE);
+			msg_prompt_win(MSG_vnd_path_ask, -1, 18, 0, 0, dev_ptr->filepath,
+				dev_ptr->filepath, STRSIZE);
+			if (dev_ptr->filepath[0] != '/') {
+				strlcpy(buf, dev_ptr->filepath, MOUNTLEN);
+				snprintf(dev_ptr->filepath, MOUNTLEN, "/%s", buf);
+			}
+			if (dev_ptr->filepath[strlen(dev_ptr->filepath) - 1] == '/')
+				dev_ptr->filepath[strlen(dev_ptr->filepath) - 1] = '\0';
 			return 0;
 		case PMV_MENU_EXIST:
-			vnds[manage_curdev].is_exist = !vnds[manage_curdev].is_exist;
+			dev_ptr->is_exist = !dev_ptr->is_exist;
 			return 0;
 		case PMV_MENU_SIZE:
-			if (vnds[manage_curdev].is_exist)
+			if (dev_ptr->is_exist)
 				return 0;
-			msg_to_show = "Size (MB)";
-			out_var = &(vnds[manage_curdev].size);
+			msg_to_show = MSG_vnd_size_ask;
+			out_var = &(dev_ptr->size);
 			break;
 		case PMV_MENU_RO:
-			vnds[manage_curdev].readonly = !vnds[manage_curdev].readonly;
+			dev_ptr->readonly = !dev_ptr->readonly;
 			return 0;
 		case PMV_MENU_MGEOM:
-			if (vnds[manage_curdev].is_exist)
+			if (dev_ptr->is_exist)
 				return 0;
-			vnds[manage_curdev].manual_geom = !vnds[manage_curdev].manual_geom;
+			dev_ptr->manual_geom = !dev_ptr->manual_geom;
 			return 0;
 		case PMV_MENU_SECSIZE:
-			if (!vnds[manage_curdev].manual_geom || vnds[manage_curdev].is_exist)
+			if (!dev_ptr->manual_geom || dev_ptr->is_exist)
 				return 0;
-			msg_to_show = "Bytes per Sector";
-			out_var = &(vnds[manage_curdev].secsize);
+			msg_to_show = MSG_vnd_bps_ask;
+			out_var = &(dev_ptr->secsize);
 			break;
 		case PMV_MENU_NSECTORS:
-			if (!vnds[manage_curdev].manual_geom || vnds[manage_curdev].is_exist)
+			if (!dev_ptr->manual_geom || dev_ptr->is_exist)
 				return 0;
-			msg_to_show = "Sectors per Track";
-			out_var = &(vnds[manage_curdev].nsectors);
+			msg_to_show = MSG_vnd_spt_ask;
+			out_var = &(dev_ptr->nsectors);
 			break;
 		case PMV_MENU_NTRACKS:
-			if (!vnds[manage_curdev].manual_geom || vnds[manage_curdev].is_exist)
+			if (!dev_ptr->manual_geom || dev_ptr->is_exist)
 				return 0;
-			msg_to_show = "Tracks per Cylinder";
-			out_var = &(vnds[manage_curdev].ntracks);
+			msg_to_show = MSG_vnd_tpc_ask;
+			out_var = &(dev_ptr->ntracks);
 			break;
 		case PMV_MENU_NCYLINDERS:
-			if (!vnds[manage_curdev].manual_geom || vnds[manage_curdev].is_exist)
+			if (!dev_ptr->manual_geom || dev_ptr->is_exist)
 				return 0;
-			msg_to_show = "Cylinders";
-			out_var = &(vnds[manage_curdev].ncylinders);
+			msg_to_show = MSG_vnd_cyl_ask;
+			out_var = &(dev_ptr->ncylinders);
 			break;
 		case PMV_MENU_REMOVE:
-			vnds[manage_curdev].enabled = 0;
+			dev_ptr->enabled = 0;
 			return 0;
 	}
 	if (out_var == NULL || msg_to_show == NULL)
@@ -673,11 +845,13 @@ partman_vnd_set_value(menudesc *m, void *arg)
 }
 
 static void
-partman_vnd_new_init(void * none)
+pm_vnd_init(void *arg, void *none)
 {
-	memset(&(vnds[manage_curdev]), 0, sizeof vnds[manage_curdev]);
-	vnds[manage_curdev] = (struct vnds_t) {
+	vnds_t *dev_ptr = arg;
+	memset(dev_ptr, 0, sizeof(*dev_ptr));
+	*dev_ptr = (struct vnds_t) {
 		.enabled = 1,
+		.blocked = 0,
 		.filepath[0] = '\0',
 		.is_exist = 0,
 		.size = 1024,
@@ -692,159 +866,200 @@ partman_vnd_new_init(void * none)
 }
 
 static int
-partman_vnd_check(int dev_num)
+pm_vnd_check(void *arg)
 {
-	if (strlen(vnds[dev_num].filepath) < 1 ||
-			vnds[dev_num].size < 1)
-		vnds[dev_num].enabled = 0;
-	return vnds[dev_num].enabled;
+	vnds_t *dev_ptr = arg;
+
+	if (dev_ptr->blocked)
+		return 0;
+	if (strlen(dev_ptr->filepath) < 1 ||
+			dev_ptr->size < 1)
+		dev_ptr->enabled = 0;
+	else {
+		pm_manage_getfreenode(&(dev_ptr->node), "vnd", &vnds_t_info);
+		if (dev_ptr->node < 0)
+			dev_ptr->enabled = 0;
+	}
+	return dev_ptr->enabled;
 }
 
+/* XXX: vnconfig always return 0? */
 static int
-partman_vnd_edit(menudesc *m, void *arg)
+pm_vnd_commit(void)
 {
-	((part_entry_t *)arg)[0].retvalue = m->cursel + 1;
+	int i, ii, error, part_suit = -1;
+	char r_o[3], buf[MOUNTLEN+3], resultpath[STRSIZE]; 
+	pm_devs_t *pm_i, *pm_suit = NULL;
 
-	return partman_manage_edit(PMV_MENU_END, partman_vnd_edit_menufmt,
-		partman_vnd_set_value, partman_vnd_check, partman_vnd_new_init,
-		NULL, ((part_entry_t *)arg)[m->cursel].dev_num, MAX_VNDS,
-		sizeof vnds[0], &(vnds[0].enabled));
-}
-
-/* TODO: should use only unallocated devices */
-/* TODO: vnconfig always return 0? */
-static int
-partman_vnd_commit(void)
-{
-	int i, not_ok;
-	char r_o[3];
+	for (i = 0; i < MAX_VND; i++) {
+		error = 0;
+		if (! pm_vnd_check(&vnds[i]))
+			continue;
 
-	for (i = 0; i < MAX_VNDS; i++) {
-		not_ok = 0;
-		if (! partman_vnd_check(i))
+		/* Trying to assign target device */
+		SLIST_FOREACH(pm_i, &pm_head, l)
+			for (ii = 0; ii < 6; ii++) {
+				strcpy(buf, pm_i->bsdlabel[ii].pi_mount);
+				if (buf[strlen(buf)-1] != '/')
+					sprintf(buf,"%s/", buf);
+				printf("%s\n",buf);
+				if (strstr(vnds[i].filepath, buf) == vnds[i].filepath)
+					if (part_suit < 0 || pm_suit == NULL ||
+						strlen(buf) > strlen(pm_suit->bsdlabel[part_suit].pi_mount)) {
+						part_suit = ii;
+						pm_suit = pm_i;
+					}
+			}
+		if (part_suit < 0 || pm_suit == NULL || 
+			pm_suit->bsdlabel[part_suit].mnt_opts == NULL ||
+			! (pm_suit->bsdlabel[part_suit].pi_flags & PIF_MOUNT))
 			continue;
+		
+		/* Mounting assigned partition and try to get real file path*/
+		if (pm_mount(pm_suit, part_suit) != 0)
+			continue;
+		snprintf(resultpath, STRSIZE, "%s/%s",
+			pm_suit->bsdlabel[part_suit].mounted,
+			&(vnds[i].filepath[strlen(pm_suit->bsdlabel[part_suit].pi_mount)]));
+
 		strcpy(r_o, vnds[i].readonly?"-r":"");
 		/* If this is a new image */
-		if (!vnds[i].is_exist)
-			not_ok += run_program(RUN_DISPLAY,
+		if (!vnds[i].is_exist) {
+			run_program(RUN_DISPLAY | RUN_PROGRESS, "mkdir -p %s ", dirname(resultpath));
+			error += run_program(RUN_DISPLAY | RUN_PROGRESS,
 						"dd if=/dev/zero of=%s bs=1m count=%d progress=100 msgfmt=human",
-						target_expand(vnds[i].filepath), vnds[i].size);
-		if (not_ok)
+						resultpath, vnds[i].size);
+		}
+		if (error)
 			continue;
-
 		/* If this is a new image with manual geometry */
 		if (!vnds[i].is_exist && vnds[i].manual_geom)
-			not_ok += run_program(RUN_DISPLAY,
-						"vnconfig %s vnd%d %s %d %d %d %d", r_o, i,
-						target_expand(vnds[i].filepath), vnds[i].secsize,
-						vnds[i].nsectors, vnds[i].ntracks,	vnds[i].ncylinders);
+			error += run_program(RUN_DISPLAY | RUN_PROGRESS,
+						"vnconfig %s vnd%d %s %d %d %d %d", r_o, vnds[i].node,
+						resultpath, vnds[i].secsize, vnds[i].nsectors,
+						vnds[i].ntracks, vnds[i].ncylinders);
 		/* If this is a existent image or image without manual geometry */
 		else
-			not_ok += run_program(RUN_DISPLAY, "vnconfig %s vnd%d %s",
-						r_o, i, target_expand(vnds[i].filepath));
-
-		if (! not_ok)
-			vnds[i].enabled = 0;
+			error += run_program(RUN_DISPLAY | RUN_PROGRESS, "vnconfig %s vnd%d %s",
+						r_o, vnds[i].node, resultpath);
+
+		if (! error) {
+			vnds[i].blocked = 1;
+			vnds[i].pm_part = part_suit;
+			vnds[i].pm = pm_suit;
+			vnds[i].pm->blocked++;
+		}
 	}
 	return 0;
 }
 
-/*** CGD ***/
+/***
+CGD
+***/
 
 static void
-partman_cgd_menufmt(menudesc *m, int opt, void *arg)
+pm_cgd_menufmt(menudesc *m, int opt, void *arg)
 {
-	int num = ((part_entry_t *)arg)[opt].dev_num;
-
-	if (cgds[num].enabled != 0) {
-		if (cgds[num].pm == NULL)
-			wprintw(m->mw, "   DISK NOT DEFINED!");
-		else
-			wprintw(m->mw, "   %s%c (%s-%d)", cgds[num].pm->diskdev,
-				cgds[num].pm_part, cgds[num].enc_type, cgds[num].key_size);
+	cgds_t *dev_ptr = ((part_entry_t *)arg)[opt].dev_ptr;
+	char desc[STRSIZE];
+
+	if (dev_ptr->enabled == 0)
+		return;
+	if (dev_ptr->pm == NULL)
+		wprintw(m->mw, "%s", msg_string(MSG_cgd_err_menufmt));
+	else {
+		snprintf(desc, STRSIZE, "(%s-%d) on %s", dev_ptr->enc_type,
+			dev_ptr->key_size, dev_ptr->pm_name);
+		wprintw(m->mw, msg_string(MSG_cgd_menufmt), dev_ptr->node, desc,
+			dev_ptr->pm->bsdlabel[dev_ptr->pm_part].pi_size /
+							(MEG / dev_ptr->pm->sectorsize));
 	}
 	return;
 }
 
 static void
-partman_cgd_edit_menufmt(menudesc *m, int opt, void *arg)
+pm_cgd_edit_menufmt(menudesc *m, int opt, void *arg)
 {
-	switch (opt){
+	cgds_t *dev_ptr = arg;
+	switch (opt) {
 		case PMC_MENU_DEV:
-			wprintw(m->mw, "Base device:    %24s", cgds[manage_curdev].pm_name);
+			wprintw(m->mw, msg_string(MSG_cgd_dev_fmt), dev_ptr->pm_name);
 			break;
 		case PMC_MENU_ENCTYPE:
-			wprintw(m->mw, "Encyption:      %24s", cgds[manage_curdev].enc_type);
+			wprintw(m->mw, msg_string(MSG_cgd_enc_fmt), dev_ptr->enc_type);
 			break;
 		case PMC_MENU_KEYSIZE:
-			wprintw(m->mw, "Key size:       %24d", cgds[manage_curdev].key_size);
+			wprintw(m->mw, msg_string(MSG_cgd_key_fmt), dev_ptr->key_size);
 			break;
 		case PMC_MENU_IVTYPE:
-			wprintw(m->mw, "IV algorithm:   %24s", cgds[manage_curdev].iv_type);
+			wprintw(m->mw, msg_string(MSG_cgd_iv_fmt), dev_ptr->iv_type);
 			break;
 		case PMC_MENU_KEYGENTYPE:
-			wprintw(m->mw, "Key generation: %24s", cgds[manage_curdev].keygen_type);
+			wprintw(m->mw, msg_string(MSG_cgd_keygen_fmt), dev_ptr->keygen_type);
 			break;
 		case PMC_MENU_VERIFYTYPE:
-			wprintw(m->mw, "Verification method:   %17s", cgds[manage_curdev].verify_type);
+			wprintw(m->mw, msg_string(MSG_cgd_verif_fmt), dev_ptr->verify_type);
 			break;
 	}
 	return;
 }
 
 static int
-partman_cgd_set_value(menudesc *m, void *arg)
+pm_cgd_set_value(menudesc *m, void *arg)
 {
 	char *retstring;
+	cgds_t *dev_ptr = arg;
 
 	switch (m->cursel) {
 		case PMC_MENU_DEV:
-			partman_cgd_disk_set(NULL);
+			pm_cgd_disk_set(dev_ptr, NULL);
 			return 0;
 		case PMC_MENU_ENCTYPE:
 			process_menu(MENU_cgd_enctype, &retstring);
-			cgds[manage_curdev].enc_type = retstring;
+			dev_ptr->enc_type = retstring;
 			if (! strcmp(retstring, "blowfish-cbc"))
-				cgds[manage_curdev].key_size = 128;
+				dev_ptr->key_size = 128;
 			if (! strcmp(retstring, "3des-cbc"))
-				cgds[manage_curdev].key_size = 192;
+				dev_ptr->key_size = 192;
 			return 0;
 		case PMC_MENU_KEYSIZE:
-			if (! strcmp(cgds[manage_curdev].enc_type, "aes-cbc"))
-				cgds[manage_curdev].key_size +=
-					(cgds[manage_curdev].key_size < 256)? 64 : -128;
-			if (! strcmp(cgds[manage_curdev].enc_type, "blowfish-cbc"))
-				cgds[manage_curdev].key_size = 128;
-			if (! strcmp(cgds[manage_curdev].enc_type, "3des-cbc"))
-				cgds[manage_curdev].key_size = 192;
+			if (! strcmp(dev_ptr->enc_type, "aes-cbc"))
+				dev_ptr->key_size +=
+					(dev_ptr->key_size < 256)? 64 : -128;
+			if (! strcmp(dev_ptr->enc_type, "blowfish-cbc"))
+				dev_ptr->key_size = 128;
+			if (! strcmp(dev_ptr->enc_type, "3des-cbc"))
+				dev_ptr->key_size = 192;
 			return 0;
 		case PMC_MENU_IVTYPE:
 			process_menu(MENU_cgd_ivtype, &retstring);
-			cgds[manage_curdev].iv_type = retstring;
+			dev_ptr->iv_type = retstring;
 			return 0;
 		case PMC_MENU_KEYGENTYPE:
 			process_menu(MENU_cgd_keygentype, &retstring);
-			cgds[manage_curdev].keygen_type = retstring;
+			dev_ptr->keygen_type = retstring;
 			return 0;
 		case PMC_MENU_VERIFYTYPE:
 			process_menu(MENU_cgd_verifytype, &retstring);
-			cgds[manage_curdev].verify_type = retstring;
+			dev_ptr->verify_type = retstring;
 			return 0;
 		case PMC_MENU_REMOVE:
-			cgds[manage_curdev].enabled = 0;
+			dev_ptr->enabled = 0;
 			return 0;
 	}
 	return -1;
 }
 
 static void
-partman_cgd_new_init(void *assign_pm)
+pm_cgd_init(void *arg1, void *arg2)
 {
-	part_entry_t disk_entrie;
+	cgds_t *dev_ptr = arg1;
+	part_entry_t *disk_entrie = arg2;
 
-	memset(&(cgds[manage_curdev]), 0, sizeof cgds[manage_curdev]);
-	cgds[manage_curdev] = (struct cgds_t) {
+	memset(dev_ptr, 0, sizeof(*dev_ptr));
+	*dev_ptr = (struct cgds_t) {
 		.enabled = 1,
+		.blocked = 0,
 		.pm = NULL,
 		.pm_name[0] = '\0',
 		.pm_part = 0,
@@ -854,26 +1069,32 @@ partman_cgd_new_init(void *assign_pm)
 		.iv_type = "encblkno1",
 		.key_size = 192,
 	};
-	if (assign_pm != NULL) {
-			disk_entrie.dev_pm = assign_pm;
-			disk_entrie.dev_num = 'a' + PART_E;
-			snprintf(disk_entrie.fullname, SSTRSIZE, "%s%c",
-				pm->diskdev, 'a' + PART_E);
-		partman_cgd_disk_set(&disk_entrie);
+	if (disk_entrie != NULL) {
+		pm_getdevstring(disk_entrie->fullname, SSTRSIZE,
+			disk_entrie->dev_ptr, disk_entrie->dev_num);
+		pm_cgd_disk_set(dev_ptr, disk_entrie);
 	}
 	return;
 }
 
 static int
-partman_cgd_check(int dev_num)
+pm_cgd_check(void *arg)
 {
-	if (cgds[manage_curdev].pm == NULL)
-		cgds[manage_curdev].enabled = 0;
-	return cgds[manage_curdev].enabled;
+	cgds_t *dev_ptr = arg;
+
+	if (dev_ptr->blocked)
+		return 0;
+	if (dev_ptr->pm == NULL)
+		dev_ptr->enabled = 0;
+	else
+		pm_manage_getfreenode(&(dev_ptr->node), "cgd", &cgds_t_info);
+		if (dev_ptr->node < 0)
+			dev_ptr->enabled = 0;
+	return dev_ptr->enabled;
 }
 
 static int
-partman_cgd_disk_set(part_entry_t *disk_entrie)
+pm_cgd_disk_set(cgds_t *dev_ptr, part_entry_t *disk_entrie)
 {
 	int alloc_disk_entrie = 0;
 	if (disk_entrie == NULL) {
@@ -881,15 +1102,15 @@ partman_cgd_disk_set(part_entry_t *disk_entrie)
 		disk_entrie = malloc (sizeof(part_entry_t));
 		if (disk_entrie == NULL)
 			return -2;
-		*disk_entrie = partman_manage_getdev(FS_CGD);
+		*disk_entrie = pm_dev_list(PM_CGD_T);
 		if (disk_entrie->retvalue < 0) {
 			free(disk_entrie);
 			return -1;
 		}
 	}
-	cgds[manage_curdev].pm = disk_entrie->dev_pm;
-	cgds[manage_curdev].pm_part = disk_entrie->dev_num;
-	strncpy(cgds[manage_curdev].pm_name, disk_entrie->fullname, SSTRSIZE);
+	dev_ptr->pm = disk_entrie->dev_ptr;
+	dev_ptr->pm_part = disk_entrie->dev_num;
+	strlcpy(dev_ptr->pm_name, disk_entrie->fullname, SSTRSIZE);
 
 	if (alloc_disk_entrie)
 		free(disk_entrie);
